Subject: Re: [v6ops] IPv4 trajectory

From: Alexandru Petrescu <[email-masked]>
Date: Wed, 01 Apr 2015 16:07:37 +0200

Le 31/03/2015 07:35, Fred Baker (fred) a écrit :
[...]

> 1) IPv4-only network
> 2) IPv4 with bits of IPv6 here and there, in some combination of overlay and native
> 3) IPv4+IPv6 (native) dual stack network
> 4) IPv6+IPv4 non-native, translated or overlay (e.g., as a service)
> 5) IPv6 with little bits of IPv4 here and there; your printer might be an example
> 6) IPv6-only

Makes sense.  These are qualifiers for networks.

One would try to fit in the computers as well, as the printer example.

It is customary to see current computers having both an IPv6 stack and 
an IPv4 stack on them.  But some computers only have IPv4, whereas the 
rest have IPv4 and IPv6 stacks.  There are no computers (to my 
knowledge) which have only IPv6 stacks.

Recently we noticed a cellular end-user device which can work only in 
IPv6 mode, or only in IPv4 mode.  But it can not have both an IPv4 
address and an IPv6 address on it even though the network to which it 
connects offers it both simultaneously on same APN.

>
> In steps 1 and 2, it is an IPv4 network, possibly with some toys in
> it playing IPv6. We might have toys playing AppleTalk and DECNet too.
> IPv4 is the workhorse, and toys is toys.
>
> In step 3, every host in the network has an IPv4 address and an IPv6
> address, or constructively could have if it wants one, and every
> router is carrying IPv4 routing as well as IPv6 routing. It’s likely
> multiplexing IPv4 addresses, and IPv4 is increasingly broken. But the
> big question is what applications and providers support IPv6; as long
> as a big one (Skype?) is not making the transition, people have a
> business reason to keep IPv4 going. As applications become dual
> stack, traffic levels approach a 50/50 distribution, barring some
> specific reason they would be forced to IPv4 or IPv6.
>
> Right now, most networks are still in step 1, and those that have a
> clue are somewhere between step 2 and step 3. But some are moving, or
> at least experimenting, with step 4.

I agree.

> steps 4-6 are fundamentally about an IPv6 network.

I agree, we're not there yet.

> In step 4, the network is optimizing configurations and costs by
> making IPv4 a translation or an overlay, but IPv4 remains an
> important aspect of the network. Obvious examples include anything
> listed. IPv4 might reach the host one way or another, or be
> translated some distance away, but a client using IPv4 can reach an
> IPv4-only server, and it can reply, and part of the path in between
> is IPv6-only.
>
> In step 5, IPv4 has taken a place comparable to AppleTalk; yes,
> there’s some there, but where, precisely? And in step 6, we have
> finally turned IPv4 off entirely, and with it probably Bisync and
> X.25.
>
>
> Now, what assumptions am I making? I believe that an IPv4 packet can
> make it end to end until step 5; it might spend part of that as a
> translated IPv6 packet or in a tunnel of some kind, but it can get
> there. As of step 5, that is no longer the case. Exactly how that
> happens is Not My Department. Note that many core networks don’t
> describe themselves as IPv4, IPv6, or dual stack networks; they
> describe themselves as MPLS networks that carry IP as a payload.
>
>
> Listing LISP... to me, LISP is yet another encapsulation, a tunnel
> broker, and one that is particularly complex. It can carry IPv6
> across an IPv4 network or IPv4 over an IPv6 network. Someone
> suggested it should be on the list, and it’s on the list. One thing I
> actually expect is that the list of technologies we might invite
> deployment reports regarding is longer than the list of technologies
> people actually use. We might learn something from that.

Makes sense.

Alex

>
>
> Is anyone’s head exploding yet? >
>
>
> _______________________________________________
> v6ops mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/v6ops
>

---

From: "Bjoern A. Zeeb" <[email-masked]>
Date: Wed, 1 Apr 2015 17:54:30 +0000

> On 01 Apr 2015, at 14:07 , Alexandru Petrescu <[email-masked]> wrote:
> 
> It is customary to see current computers having both an IPv6 stack and an IPv4 stack on them.  But some computers only have IPv4, whereas the rest have IPv4 and IPv6 stacks.  There are no computers (to my knowledge) which have only IPv6 stacks.

One of my desktop systems does (not have IPv4 support anymore; and to my knowledge you can just disable it on Windows as well, so it’s not a big deal anymore).

— 
Bjoern A. Zeeb                                  Charles Haddon Spurgeon:
"Friendship is one of the sweetest joys of life.  Many might have failed
 beneath the bitterness of their trial  had they not found a friend."

---

From: James Woodyatt <[email-masked]>
Date: Wed, 1 Apr 2015 18:30:45 -0500

On Wed, Apr 1, 2015 at 9:07 AM, Alexandru Petrescu <
[email-masked]> wrote:

>
> It is customary to see current computers having both an IPv6 stack and an
> IPv4 stack on them.  But some computers only have IPv4, whereas the rest
> have IPv4 and IPv6 stacks.  There are no computers (to my knowledge) which
> have only IPv6 stacks.
>

Sigh. Computing platforms where the only network interfaces are
6LoWPAN-over-foo. These exist today, and they are not just laboratory toys.

-- 
james woodyatt <[email-masked]>
Nest Labs, Communications Engineering

---

From: Alexandru Petrescu <[email-masked]>
Date: Thu, 02 Apr 2015 08:36:26 +0200

Sorry to insist on this, just as side note.

Le 01/04/2015 19:54, Bjoern A. Zeeb a écrit :
>> It is customary to see current computers having both an IPv6 stack
>> and an IPv4 stack on them.  But some computers only have IPv4,
>> whereas the rest have IPv4 and IPv6 stacks.  There are no
>> computers (to my knowledge) which have only IPv6 stacks.
>
> One of my desktop systems does (not have IPv4 support anymore;

In general I can agree with you, in a sense where maybe a computer is
not reachable on IPv4 from another computer; maybe part of IPv4 support
is no more there.

> and to my knowledge you can just disable it on Windows as well,

Right - uncheck the IPv4 box, and check IPv6 on a computer Windows 7's
"Properties" of the network interface - it works.

But, after this, one can still ping 127.0.0.1, the routing table
still contains pure IPv4 entries, the domain name (which only exists in
IPv4) is still showing in ipconfig /all, the computer is still
receiving TCP and TLSv1 re-transmissions from its earlier connections.
Worse, the IPv4-only applications report errors which are not
explicitely telling there is no such address family.  I guess even netsh
interface ipv4 add address will work ok.

(compared to an IPv4-only computer: routing table does not show anything
making think IPv6, etc.)

I guess unchecking the IPv4 box simply removes IPv4 addresses from
interfaces and stops the DHCP client, maybe puts the interface down; but
it will not remove the IPv4 stack from the kernel, will not ARP inform
the router it has no more IPv4, will not recompile the apps to remove
the IPv4-only socket interfaces, will not forbid adding manually IPv4
addresses.

> so it’s not a big deal anymore).

I beg to differ, as I see it this is still far away from an ideal where
only IPv6 were present in the computer.

Alex

>
> — Bjoern A. Zeeb                                  Charles Haddon
> Spurgeon: "Friendship is one of the sweetest joys of life.  Many
> might have failed beneath the bitterness of their trial  had they
> not found a friend."
>
>
>

---

From: Alexandru Petrescu <[email-masked]>
Date: Thu, 02 Apr 2015 08:43:36 +0200

Le 02/04/2015 01:30, James Woodyatt a écrit :
> On Wed, Apr 1, 2015 at 9:07 AM, Alexandru Petrescu
> <[email-masked] <mailto:[email-masked]>>
> wrote:
>
>
> whereas the rest have IPv4 and IPv6 stacks.  There are no computers
> (to my knowledge) which have only IPv6 stacks.
>
>

Right, this is something that deserves consideration.

I wonder though whether they are directly connectable to the Internet.
Last time I checked a 6lowpan IPv6-only computer it was a reduced IPv6 -
one had to go through a form of middle-box to reach it.  E.g. one
wouldnt ssh into a 6lowpan device, would not manage it directly, but
would need a CoAP gw, or a PC attached with USB to be on it.

But I will ask around to see the current situation.

Alex

>
>
> -- james woodyatt <[email-masked] <mailto:[email-masked]>> Nest
> Labs, Communications Engineering

---

From: "Bjoern A. Zeeb" <[email-masked]>
Date: Thu, 2 Apr 2015 11:04:41 +0000

> On 02 Apr 2015, at 06:36 , Alexandru Petrescu <[email-masked]> wrote:
> 

On FreeBSD I compile it out of my kernel and parts of user space if I want to.  We did this for World IPv6 Day almost 4 years ago: http://www.prweb.com/releases/2011/6/prweb8529718.htm

If you used FreeBSD jails for services you could run them IPv6-only since FreeBSD 7.2 and you do get “Address Family Not Supported” back for every IPv4 operation you try to do (7.2 was released in May 2009).  Gosh, been doing this for more than 5 years already.

> “Properties" of the network interface - it works.

Wrong:

netsh interface ipv4 uninstall
and reboot

and you’ll not see IPv4 anymore in route print or ipconfig /all and ping 127.1 will no longer work but error on you.

> only IPv6 were present in the computer.

Well, better start living it today and we can have a lot better operational discussions on the end-node (client/server systems) side.   I have 7 IPv4 addresses left in use in total for all my infrastructure (and could condense it to 2 or 3 if I wanted really badly).  And the only reason I keep those is for the ipv4-only world to reach NS/MX/Web.  But that’s just me.  Leave a /27 for a SMB and be good ;-)

—

---

From: Alexandru Petrescu <[email-masked]>
Date: Thu, 02 Apr 2015 19:44:33 +0200

Le 02/04/2015 13:04, Bjoern A. Zeeb a écrit :
>>>> It is customary to see current computers having both an IPv6
>>>> stack and an IPv4 stack on them.  But some computers only have
>>>> IPv4, whereas the rest have IPv4 and IPv6 stacks.  There are no
>> In general I can agree with you, in a sense where maybe a computer
>> is not reachable on IPv4 from another computer; maybe part of IPv4
>> support is no more there.
>
> On FreeBSD I compile it out of my kernel and parts of user space if
> I want to.  We did this for World IPv6 Day almost 4 years ago:
> http://www.prweb.com/releases/2011/6/prweb8529718.htm
>
> If you used FreeBSD jails for services you could run them IPv6-only
> since FreeBSD 7.2 and you do get “Address Family Not Supported” back
> for every IPv4 operation you try to do (7.2 was released in May
> 2009).  Gosh, been doing this for more than 5 years already.

That's good for BSD then, I am happy for it.  Does it remove the
127.0.0.1 from its /etc/hosts too?

In linux you can't make the IPv4 stack or any of its features into a
module.  It's builtin.

>> Right - uncheck the IPv4 box, and check IPv6 on a computer Windows
>> 7's “Properties" of the network interface - it works.
>
> Wrong:
>
> netsh interface ipv4 uninstall and reboot

I'd like to try that.  But if it fails can I 'install' it back somehow?

(because I already experienced some hangs with checking off IPv4 while
wireshark running - for some reasons some apps think that if IPv4 is not
there then networking is not there although they are IPv6-capable).

> and you’ll not see IPv4 anymore in route print or ipconfig /all and
> ping 127.1 will no longer work but error on you.

And Windows' hosts file containing 127?

>> I beg to differ, as I see it this is still far away from an ideal
>> where only IPv6 were present in the computer.
>
>
> Well, better start living it today and we can have a lot better
> operational discussions on the end-node (client/server systems)
> side. I have 7 IPv4 addresses left in use in total for all my
> infrastructure (and could condense it to 2 or 3 if I wanted really
> badly).  And the only reason I keep those is for the ipv4-only world
> to reach NS/MX/Web.  But that’s just me.  Leave a /27 for a SMB and
> be good ;-)

Congratulations.

I have no BSD here, except for the proprietary derivatives (ios,
windows, etc).  For all code that I can modify it's linux.  Given that I
can't turn off IPv4 until linux gives a means to.

Do you know whether ios has such a means to turn off fully IPv4?

Alex

---

From: Alexandru Petrescu <[email-masked]>
Date: Thu, 02 Apr 2015 19:52:46 +0200

Le 02/04/2015 08:43, Alexandru Petrescu a écrit :
>> <[email-masked]
>> <mailto:[email-masked]>> wrote:
>>
>>
> I wonder though whether they are directly connectable to the
> Internet. Last time I checked a 6lowpan IPv6-only computer it was a
> reduced IPv6 - one had to go through a form of middle-box to reach
> it.  E.g. one wouldnt ssh into a 6lowpan device, would not manage it
> directly, but would need a CoAP gw, or a PC attached with USB to be
> on it.
>

I asked around for some 6lowpan Contiki situation.  We still need to
check serial output of modem verbose looking for IPv4 literals.

But, in general, contiki does have this ability to only include IPv6,
and no IPv4 stack.

There are other questions there, though.

For example, some contiki devices still use fec0 addresses.

IPv6 contiki devices are not reachable by other means than CoAP (there
is no TCP or HTTP for example), by using a particular plugin in some
browser.  You can't telnet or rsh into it.

You can't imagine sending a 6lowpan device a pure RA (it must be an RPL
ICMP message).

You can't connect a 6lowpan-enabled-Router somewhere at an edge of the
Internet where prefixes are already /64, because 6lowpan needs /64 as well.

I may be wrong in some of these aspects, but for these doubts I still
dont think 6lowpan is IPv6, and I dont think 6lowpan devices are on the
IPv6 Internet.

Or is there an address of an IPv6-only 6lowpan device I could ping6?

Alex

> _______________________________________________ v6ops mailing list
> [email-masked] https://www.ietf.org/mailman/listinfo/v6ops

---

From: Mark Andrews <[email-masked]>
Date: Fri, 03 Apr 2015 05:00:46 +1100

In message <[email-masked]>, Alexandru Petrescu writes:
> Le 02/04/2015 13:04, Bjoern A. Zeeb a =E9crit :
> >
> >> Le 01/04/2015 19:54, Bjoern A. Zeeb a =E9crit :
> > since FreeBSD 7.2 and you do get =93Address Family Not Supported=94 back

It looks like Linux needs some work then.
 
> >> 7's =93Properties" of the network interface - it works.
> >
> > Wrong:
> >

Which is a application bug that should be reported.
 
> > and you=92ll not see IPv4 anymore in route print or ipconfig /all and

Do you want to rip all the A records out of the DNS as well?  If
the getaddrinfo() is properly written the IPv4 addresses will be
filtered from the responses with AI_ADDRCONFIG set so it shouldn't
matter if it is still there.

> >>> so it=92s not a big deal anymore).
> >>
> > to reach NS/MX/Web.  But that=92s just me.  Leave a /27 for a SMB and
> > be good ;-)
> 
> Congratulations.
> 

You have a editor, a compiler and the source.  You have the means
to do it.  Whether you have the skill / inclination to do it is
another matter.

> > =97 Bjoern A. Zeeb                                  Charles Haddon
-- 
Mark Andrews, ISC
1 Seymour St., Dundas Valley, NSW 2117, Australia
PHONE: +61 2 9871 4742                 INTERNET: [email-masked]

---

From: Alexandru Petrescu <[email-masked]>
Date: Thu, 02 Apr 2015 20:08:55 +0200

Le 02/04/2015 20:00, Mark Andrews a écrit :
[...]
> Do you want to rip all the A records out of the DNS as well?

Right.  That is necessary in order to obtain IPv6-only.  But it looks
like a huge task to remove all A records from DNS.

This makes think about removing all 500k IPv4 routes from the DFZ - also
a huge task.

> If the getaddrinfo() is properly written the IPv4 addresses will be

That would still be IPv4 taking space on disk; taking bandwidth on
network up to Client (AI_ filtering is local, right?).

>>>> I beg to differ, as I see it this is still far away from an
>>>> ideal where only IPv6 were present in the computer.
>>>
>>>
>>> infrastructure (and could condense it to 2 or 3 if I wanted
>>> really badly).  And the only reason I keep those is for the
>>> ipv4-only world to reach NS/MX/Web.  But that=92s just me.
>>> Leave a /27 for a SMB and be good ;-)
>>
>> Congratulations.
>>
>> windows, etc).  For all code that I can modify it's linux.  Given
>> that I can't turn off IPv4 until linux gives a means to.
>
> You have a editor, a compiler and the source.  You have the means to
> do it.  Whether you have the skill / inclination to do it is another
> matter.

Ressource may be there, and the pleasure of removing; but reticence
worrying doing it too early is there too.  Maybe someone somewhere still
needs this little IPv4 and it will break otherwise; wouldnt touch it yet.

Alex

>>> =97 Bjoern A. Zeeb                                  Charles
>>> Haddon Spurgeon: "Friendship is one of the sweetest joys of
>>> life. Many might have failed beneath the bitterness of their
>>> trial  had they not found a friend."
>>>
>>>
>>>
>>
>>

---

From: James Woodyatt <[email-masked]>
Date: Thu, 2 Apr 2015 13:31:27 -0500

On Thu, Apr 2, 2015 at 12:52 PM, Alexandru Petrescu <
[email-masked]> wrote:

>
> But, in general, contiki does have this ability to only include IPv6, and
> no IPv4 stack.
>

ConTiki isn't the only 6LoWPAN platform to consider. You could ask members
of Thread Group <http://www.threadgroup.org/> if any of their commercial
products in development now are doing this. (You could ask me, but I
couldn't possibly comment.)

> You can't imagine sending a 6lowpan device a pure RA (it must be an
> RPL ICMP message).
>

According to the most recently published technical presentations, Thread
networks do not use RPL or RFC 6775. The specification for their border
routers is not yet published.

> You can't connect a 6lowpan-enabled-Router somewhere at an edge of
> the Internet where prefixes are already /64, because 6lowpan needs /64 as
> well.
>

That's right. It's one of the reasons I've been so active in the HOMENET
working group.

> I may be wrong in some of these aspects, but for these doubts I still dont
> think 6lowpan is IPv6, and I dont think 6lowpan devices are on the IPv6
> Internet.
>

I think you're absolutely wrong to doubt that 6LoWPAN devices can be fully
compliant IPv6 nodes reachable via the public Internet.

> Or is there an address of an IPv6-only 6lowpan device I could ping6?

I'm fairly certain they must exist in public somewhere. Just not anywhere
known to me. Today.

---

From: Brian E Carpenter <[email-masked]>
Date: Fri, 03 Apr 2015 08:23:44 +1300

On 03/04/2015 07:08, Alexandru Petrescu wrote:
> Right.  That is necessary in order to obtain IPv6-only.

You confuse me. Why is it necessary? To the contrary, it is
necessary *not* to do this until the last IPv4 user has vanished.

You might of course consider a resolver that returns NXDOMAIN for
any A query, if you want to hide IPv4 from a local domain.

> But it looks

And equally undesirable. Again, you could locally render all
IPv4 routes unreachable, if you really wanted to.

   Brian